package checkmk

import "fmt"

// Error implements a transfer specific error
type Error struct {
	Name     string
	HostUUID string
	Message  string
	Err      error
}

// Unwrap implements errors.Unwrap
func (e *Error) Unwrap() error {
	return e.Err
}

// Unwrap implements errors.Error
func (e *Error) Error() string {
	name := "Unknown"
	if e.Name != "" {
		name = e.Name
	}
	host := ""
	if e.HostUUID != "" {
		host = e.HostUUID + " "
	}
	if e.Err != nil {
		if e.Message != "" {
			return fmt.Sprintf("[%s] %scheckmk %s: %s", name, host, e.Message, e.Err.Error())
		}
		return fmt.Sprintf("[%s] %scheckmk: %s", name, host, e.Err.Error())
	}
	return fmt.Sprintf("[%s] %scheckmk %s", name, host, e.Message)
}
